/*
 * raid0.h
 *
 * (c) 2003 Pawel Jakub Dawidek <jules@garage.freebsd.pl>
 * All rights reserved.
 *
 * $Id: raid0.h,v 1.1 2004/02/05 12:22:08 jules Exp $
 */

#ifndef	_RAID0_H_
#define	_RAID0_H_

#define	G_RAID0_CLASS_NAME	"RAID0"
#define	G_RAID0_MAGIC		"GEOM:RAID0:0000"

struct g_raid0_metadata {
	char		md_magic[16];	/* magic string */
	char		md_name[16];	/* stripe name */
	uint32_t	md_id;		/* id */
	uint16_t	md_no;		/* disk number in stripe */
	uint16_t	md_all;		/* total numer of disks in stripe */
	uint32_t	md_stripesize;	/* stripe size */
};
static __inline void
g_raid0_metadata_enc(struct g_raid0_metadata *md, u_char *data)
{

	bcopy(md->md_magic, data, sizeof(md->md_magic));
	data += sizeof(md->md_magic);
	bcopy(md->md_name, data, sizeof(md->md_name));
	data += sizeof(md->md_name);
	le32enc(data, md->md_id);
	data += sizeof(md->md_id);
	le16enc(data, md->md_no);
	data += sizeof(md->md_no);
	le16enc(data, md->md_all);
	data += sizeof(md->md_all);
	le32enc(data, md->md_stripesize);
#if 0
	data += sizeof(md->md_stripesize);
#endif
}
static __inline void
g_raid0_metadata_dec(u_char *data, struct g_raid0_metadata *md)
{

	bcopy(data, md->md_magic, sizeof(md->md_magic));
	data += sizeof(md->md_magic);
	bcopy(data, md->md_name, sizeof(md->md_name));
	data += sizeof(md->md_name);
	md->md_id = le32dec(data);
	data += sizeof(md->md_id);
	md->md_no = le16dec(data);
	data += sizeof(md->md_no);
	md->md_all = le16dec(data);
	data += sizeof(md->md_all);
	md->md_stripesize = le32dec(data);
#if 0
	data += sizeof(md->md_stripesize);
#endif
}

#endif	/* _RAID0_H_ */
